#include <Adafruit_NeoPixel.h>

//array of 120 LEDS, Digital pin 6
Adafruit_NeoPixel strip = Adafruit_NeoPixel(120, 6, NEO_GRB + NEO_KHZ800);

//preallocating different colours
uint32_t red = strip.Color(255, 0, 0);
uint32_t orange = strip.Color(201, 30, 0);
uint32_t yellow = strip.Color(255, 100, 0);
uint32_t green = strip.Color(0, 255, 0);
uint32_t blue = strip.Color(0, 255, 255);
uint32_t indigo = strip.Color(126, 0, 255);
uint32_t violet = strip.Color(204, 0, 204);

//reorganising the LEDS into a array that adressses them in either horizontal or vertical order, instead of going from 0-120.
//Allows to easily code patterns to follow a specific path
unsigned char horizontal[120]= {0, 11, 12, 23, 24, 35, 36, 47, 48, 59, 60, 71, 72, 83, 84, 95, 96, 107, 108, 119, 1, 10, 13, 22, 25, 34, 37, 46, 49, 58, 61, 70, 73, 82, 85, 94, 97, 106, 109, 118, 2, 9, 14, 21, 26, 33, 38, 45, 50, 57, 62, 69, 74, 81, 86, 93, 98, 105, 110, 117, 3, 8, 15, 20, 27, 32, 39, 44, 51, 56, 63, 68, 75, 80, 87, 92, 99, 104, 111, 116, 4, 7, 16, 19, 28, 31, 40, 43, 52, 55, 64, 67, 76, 79, 88, 91, 100, 103, 112, 115, 5, 6, 17, 18, 29, 30, 41, 42, 53, 54, 65, 66, 77, 78, 89, 90, 101, 102, 113, 114};
unsigned char vertical[120]= {0, 1, 2, 3, 4, 5, 11, 10, 9, 8, 7, 6, 12, 13, 14, 15, 16, 17, 23, 22, 21, 20, 19, 18, 24, 25, 26, 27, 28, 29, 35, 34, 33, 32, 31, 30, 36, 37, 38, 39, 40, 41, 47, 46, 45, 44, 43, 42, 48, 49, 50, 51, 52, 53, 59, 58, 57, 56, 55, 54, 60, 61, 63, 63, 64, 65, 71, 70, 69, 68, 67, 66, 72, 73, 74, 75, 76, 77, 83, 82, 81, 80, 79, 78, 84, 85, 86, 87, 88, 89, 95, 94, 93, 92, 91, 90, 96, 97, 98, 99, 100, 101, 107, 106, 105, 104, 103, 102, 108, 109, 110, 111, 112, 113, 119, 118, 117, 116, 115, 114};
  

void setup() {
  // initialize serial communications at 9600 bps:
  Serial.begin(9600);
 pinMode(9, INPUT_PULLUP); 
   strip.begin();
  strip.show(); // Initialize all pixels to 'off'
}

void loop() {
  while(1==1){
colorWipe(red, 0); 
colorWipe(orange, 1000); 
colorWipe(yellow, 1000);    
colorWipe(green, 1000);
colorWipe(blue, 1000);
colorWipe(indigo, 1000);
colorWipe(violet, 1000);
verticalRainbow();
verticalColours(red, 1000);
verticalColours(orange, 1000);
verticalColours(yellow, 1000);
verticalColours(green, 1000);
verticalColours(blue, 1000);
verticalColours(indigo, 1000);
verticalColours(violet, 1000);
horizontalColours(red, 1000);
horizontalColours(orange, 1000);
horizontalColours(yellow, 1000);
horizontalColours(green, 1000);
horizontalColours(blue, 1000);
horizontalColours(indigo, 1000);
horizontalColours(violet, 1000);
horizontalRainbow();

}  
}
                    

//functions for different patterns 
//void Name(colour, timeBetweenLEDS)

//sweeps single colour across strip
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(i, c); //i = ledNUM, 
      strip.show();
      delay(wait);
  }
}

//will gradually change single colour up and down collumns of original matrix
void verticalColours(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(vertical[i], c); //i = ledNUM, 
      strip.show();
      delay(wait);
  }
}

//will gradually change single colour up and down collumns of original matrix
void horizontalColours(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip.numPixels(); i++) {
      strip.setPixelColor(horizontal[i], c); //i = ledNUM, 
      strip.show();
      delay(wait);
  }
}

//will change the colour of a vertical column of the matrix
void verticalColoursTest(uint32_t c, uint8_t wait, int number) {
  for(uint16_t i=number; i<(number+6); i++) { //number is first led in vertical collumn
      strip.setPixelColor(vertical[i], c); //i = ledNUM, 
      strip.show();
      delay(wait);
  }
}
//will change the colour of a horizontal row of the matrix
void horizontalColoursTest(uint32_t c, uint8_t wait, int number) {
  for(uint16_t i=number; i<(number+20); i++) { //number is first led of matrix row
      strip.setPixelColor(horizontal[i], c); //i = ledNUM, 
      strip.show();
      delay(wait);
  }
}

//gradually change all the rows into the rainbow
void horizontalRainbow() {
      horizontalColoursTest(red, 200, 0);  
      horizontalColoursTest(orange, 200, 20);
      horizontalColoursTest(yellow, 200, 40);
      horizontalColoursTest(green, 200, 60);
      horizontalColoursTest(blue, 200, 80);
      horizontalColoursTest(indigo, 200, 100);
      strip.show();
}

//gradually change all the columns into the rainbow
void verticalRainbow() {
    verticalColoursTest(red, 200, 0);  
    verticalColoursTest(orange, 200, 6);
    verticalColoursTest(yellow, 200, 12);
    verticalColoursTest(green, 200, 18);
    verticalColoursTest(blue, 200, 24);
    verticalColoursTest(indigo, 200, 30);
    verticalColoursTest(violet, 200, 36);
    verticalColoursTest(red, 200, 42);  
    verticalColoursTest(orange, 200, 48);
    verticalColoursTest(yellow, 200, 54);
    verticalColoursTest(green, 200, 60);
    verticalColoursTest(blue, 200, 66);
    verticalColoursTest(indigo, 200, 72);
    verticalColoursTest(violet, 200, 78);
    verticalColoursTest(red, 200, 84);  
    verticalColoursTest(orange, 200, 90);
    verticalColoursTest(yellow, 200, 96);
    verticalColoursTest(green, 200, 102);
    verticalColoursTest(blue, 200, 108);
    verticalColoursTest(indigo, 200, 114);
strip.show();
}
